#include <windows.h>
#include <shellapi.h>
#include <taskbar.h>

BOOL TaskBarAddIcon(HWND hControllingWnd, UINT uWMTaskbar, UINT uTaskBarID, HICON hTaskBarIcon, LPSTR lpszTip)
 {
  BOOL bRetVal;
  NOTIFYICONDATA nd;

  nd.cbSize           = sizeof(nd);
  nd.hWnd             = hControllingWnd;
  nd.uCallbackMessage = uWMTaskbar;
  nd.uID              = uTaskBarID;
  nd.hIcon            = hTaskBarIcon;
  if (lpszTip)
    lstrcpyn(nd.szTip, lpszTip, min(lstrlen(lpszTip) + 1, sizeof(nd.szTip)));

  nd.uFlags = NIF_MESSAGE | (hTaskBarIcon ? NIF_ICON : 0) | (lpszTip ? NIF_TIP : 0);

  bRetVal = Shell_NotifyIcon( NIM_ADD, &nd );
  return bRetVal;
 }

BOOL TaskBarDeleteIcon(HWND hControllingWnd, UINT uTaskBarID)
 {
  NOTIFYICONDATA nd;

  nd.cbSize = sizeof(nd);
  nd.hWnd   = hControllingWnd;
  nd.uID    = uTaskBarID;

  return Shell_NotifyIcon(NIM_DELETE, &nd);
 }

BOOL TaskBarSetToolTip(HWND  hControllingWnd, UINT  uTaskBarID, LPSTR lpszTip)
 {
  NOTIFYICONDATA nd;

  nd.cbSize = sizeof(nd);
  nd.hWnd   = hControllingWnd;
  nd.uID    = uTaskBarID;

  nd.uFlags = NIF_TIP;

  if (lpszTip)
   lstrcpyn(nd.szTip, lpszTip, min(lstrlen(lpszTip) + 1, sizeof(nd.szTip)));
  else
   nd.szTip[0] = '\0';

  return Shell_NotifyIcon(NIM_MODIFY, &nd);
 }

BOOL TaskBarSetIcon(HWND hControllingWnd, UINT uTaskBarID, HICON hTaskBarIcon)
 {
  NOTIFYICONDATA nd;

  nd.cbSize = sizeof(nd);
  nd.hWnd   = hControllingWnd;
  nd.uID    = uTaskBarID;

  nd.uFlags = NIF_ICON;
  nd.hIcon  = hTaskBarIcon;

  return Shell_NotifyIcon(NIM_MODIFY, &nd);
 }

