/*
 to do:
  -design?
*/
#include <owl\pch.h>
#include <windows.h>
#include <owl\button.h>
#include <owl\checkbox.h>
#include <owl\dialog.h>
#include <owl\edit.h>
#include <owl\combobox.h>
#include <owl\listbox.h>
#include <owl\listwind.h>
#include <owl\slider.h>
#include <owl\opensave.h>
#include <owl\imagelst.h>
#include <owl\radiobut.h>
#include <owl/splashwi.h>
#include <owl\propsht.h>
#include <owl\groupbox.h>
#include "processloaded.h"
#include <vwcl\vweb.hpp>

//#include "midasdll.h"
#include "mem.h"
#include "string.h"
#include "taskbar.h"

#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <shellapi.h>

#include <modality.h>
#include <midasplayer.h>
#pragma hdrstop
#pragma warn -aus

lpMIDASPlayer midas;

#define STR_NO_EXTENSION "?"

class TInfoDlg : public TDialog
 {
  public:
   TInfoDlg(TWindow*);
   void CmMail();
   void CmHomepage();

  DECLARE_RESPONSE_TABLE(TInfoDlg);
 };

DEFINE_RESPONSE_TABLE1(TInfoDlg, TDialog)
 EV_BN_CLICKED(105, CmMail),
 EV_BN_CLICKED(106, CmHomepage),
END_RESPONSE_TABLE;

/******************************************************************************/
// TPrefDlg Interface
/******************************************************************************/

class TMIDASPage : public TPropertyPage
 {
  public:
   TMIDASPage(TPropertySheet* parent);
   ~TMIDASPage();
   virtual void SetupWindow();
   virtual int Apply(TNotify&);
   void SetupGUI();

   TComboBox *cb_Quality, *cb_Mixrate, *cb_Filter;
   TStatic *st_version;
 };

class TPrefPage : public TPropertyPage
 {
  public:
   TPrefPage(TPropertySheet* parent);
   virtual void SetupWindow();
   virtual int Apply(TNotify&);
   void SetupGUI();

   TCheckBox *cb_LoadNames, *cb_BadFiles, *cb_IconTNA, *cb_ShowSplash;
 };

/******************************************************************************/
// TInstrDialog Interface
/******************************************************************************/
class TInstrDialog : public TDialog
{
  public:
   TListBox *InstrList;

   TFont f;
   TInstrDialog(TWindow* parent = 0, TResId resId ="DLG_INSTRUMENTS", TModule* module = 0);

   void UpdateInstrList();
   virtual void SetupWindow();
};

/******************************************************************************/
// TInstrFrameWindow Interface
/******************************************************************************/
class TInstrFrameWindow : public TFrameWindow
{
  public:
   TInstrFrameWindow (TWindow* parent, const char far *title = APP_TITLE,
                   TWindow *clientWnd = 0, BOOL shrinkToClient = true)
                  :TFrameWindow (parent, title, clientWnd, shrinkToClient)
   {
     Attr.Style = WS_POPUPWINDOW &~WS_THICKFRAME &~WS_MAXIMIZEBOX &~WS_CAPTION;
     Attr.ExStyle |= WS_EX_DLGMODALFRAME;
   }
};

/******************************************************************************/
// TDiskDialog Interface
/******************************************************************************/
class TDiskDialog : public TDialog
{
  public:
   TListWindow *FileList;
   TImageList *img;

   lpDMM *OldDMM, *ContextDMM;

   TDiskDialog(TWindow* parent = 0, TResId resId ="DLG_DISK", TModule* module = 0);
   virtual void SetupWindow();
   virtual void CleanupWindow();

   void SetupGUI();
   void UpdateListView();
   void AddNewModules();
   void PlayModule();
   void AddModule(const char *fn, const char *track = NO_TRACK_INFO);
   void AddModuleToListView(lpDMM *dmm);
   void MarkModule();

   void EvModuleDblclk();
   void EvContextMenu(HWND child, int x, int y);
   void CmPlay();
   void CmDelete();
   void CmAddFile();
   void CmLstNew();
   void CmLstOpen();
   void CmLstSave();
   void CmLstSaveAs();
   void CmRetrieveNames();
   void CmEmpty();

   void EvDropFiles(TDropInfo dropInfo);
   void ProcessCmdLine();
   void LoadModulelistWithCmdLineCheck();
   void UpdateTitle();
   int FileExists(const char *p);
   int FindDMMInListView(lpDMM* dmm);

   DECLARE_RESPONSE_TABLE(TDiskDialog);
};

DEFINE_RESPONSE_TABLE1(TDiskDialog, TWindow)
 EV_NM_DBLCLK(100, EvModuleDblclk),
 EV_WM_CONTEXTMENU,
 EV_COMMAND(2100, CmPlay),
 EV_COMMAND(2102, CmDelete),
 EV_COMMAND(2101, CmAddFile),
 EV_COMMAND(2103, CmLstNew),
 EV_COMMAND(2104, CmLstOpen),
 EV_COMMAND(2105, CmLstSave),
 EV_COMMAND(2106, CmLstSaveAs),
 EV_COMMAND(1510, CmEmpty),
 EV_COMMAND(4711, CmRetrieveNames),
 EV_WM_DROPFILES,
END_RESPONSE_TABLE;

/******************************************************************************/
// TDiskFrameWindow Interface
/******************************************************************************/
class TDiskFrameWindow : public TFrameWindow
{
  public:
   TDiskFrameWindow (TWindow* parent, const char far *title = APP_TITLE,
                   TWindow *clientWnd = 0, BOOL shrinkToClient = true)
                  :TFrameWindow (parent, title, clientWnd, shrinkToClient)
   {
     Attr.Style = WS_POPUPWINDOW &~WS_THICKFRAME &~WS_MAXIMIZEBOX &~WS_CAPTION;
     Attr.ExStyle |= WS_EX_DLGMODALFRAME;
     EnableKBHandler();
   }
};

/******************************************************************************/
// TMainDialog Interface
/******************************************************************************/
class TMainDialog : public TDialog
 {
  public:

  TStatic *st_title, *st_fname, *st_type, *st_arr, *st_pat, *st_chan, *st_instr;
  THSlider *sl_pos;
  TVSlider *sl_vol;
  TButton *bt_play, *bt_stop, *bt_forward, *bt_rewind, *bt_frewind, *bt_fforward, *bt_fauto;
  TCheckBox *cb_repeat, *cb_repeat2, *cb_disk, *cb_instr;
  TRadioButton *rb_shuffle, *rb_forward, *rb_backward;

  TIcon *icoSmall, *icoNothing, *icoPlay;
  TFont f;
  TPopupMenu *pop;
  HANDLE hMMF;
  int Buffering_LastPos;

  TMainDialog(TWindow* parent = 0, TResId resId ="DLG_MAIN", TModule* module = 0);
  ~TMainDialog();

  void CmPlay();
  void CmStop();
  void CmForward();
  void CmRewind();
  void CmFForward();
  void CmFRewind();
  void CmFAuto();
  void CmRepeat();
  void CmRepeat2();
  void CmDisk();
  void CmInstr();
  void CmShuffle();
  void CmStBackward();
  void CmStForward();
  void CmMnuShuffle();
  void CmMnuBackward();
  void CmMnuForward();
  void CmMnuRepeat1();
  void CmMnuRepeat();
  void CmAbout();
  void CmActivate();
  void CmPref();
  void CmMnuDisk();
  void CmMnuInstr();
  void CmMnuExit();
  void CmLstNew();
  void CmLstOpen();
  void CmLstSave();
  void CmLstSaveAs();
  void CmMnuHelp();

  virtual void SetupWindow();
  virtual void CleanupWindow();

  void ShowStuckInfo();
  void ShowVarInfo();
  void SetupOptions();
  void SetupGUI();
  void UpdateState();

  void ProcessMMF();
  void InitMMF();
  void CloseMMF();
  void UpdateFlags();

  void EvTimer(uint timerId);
  void EvTrack();
  void EvVol();
  LRESULT EvTNANotify(WPARAM, LPARAM);
  LRESULT EvAfterInit(WPARAM, LPARAM);

  DECLARE_RESPONSE_TABLE(TMainDialog);
};

DEFINE_RESPONSE_TABLE1(TMainDialog, TDialog)
 EV_MESSAGE(WM_AFTERINIT, EvAfterInit),
 EV_MESSAGE(WM_TNANOTIFY, EvTNANotify),
 EV_BN_CLICKED(107, CmPlay),
 EV_BN_CLICKED(108, CmStop),
 EV_BN_CLICKED(112, CmForward),
 EV_BN_CLICKED(111, CmRewind),
 EV_BN_CLICKED(110, CmFForward),
 EV_BN_CLICKED(113, CmFAuto),
 EV_BN_CLICKED(109, CmFRewind),
 EV_BN_CLICKED(118, CmRepeat),
 EV_BN_CLICKED(116, CmStBackward),
 EV_BN_CLICKED(114, CmStForward),
 EV_BN_CLICKED(119, CmShuffle),
 EV_BN_CLICKED(122, CmRepeat2),
 EV_BN_CLICKED(120, CmDisk),
 EV_BN_CLICKED(121, CmInstr),
 EV_WM_TIMER,

 EV_SB_BEGINTRACK(115, EvTrack),
 EV_SB_BOTTOM(115, EvTrack),
 EV_SB_ENDSCROLL(115, EvTrack),
 EV_SB_LINEDOWN(115, EvTrack),
 EV_SB_LINEUP(115, EvTrack),
 EV_SB_PAGEDOWN(115, EvTrack),
 EV_SB_PAGEUP(115, EvTrack),
 EV_SB_THUMBPOSITION(115, EvTrack),
 EV_SB_TOP(115, EvTrack),

 EV_SB_BEGINTRACK(117, EvVol),
 EV_SB_BOTTOM(117, EvVol),
 EV_SB_ENDSCROLL(117, EvVol),
 EV_SB_LINEDOWN(117, EvVol),
 EV_SB_LINEUP(117, EvVol),
 EV_SB_PAGEDOWN(117, EvVol),
 EV_SB_PAGEUP(117, EvVol),
 EV_SB_THUMBPOSITION(117, EvVol),
 EV_SB_TOP(117, EvVol),

 EV_COMMAND(3106, CmPref),
 EV_COMMAND(3101, CmFForward),
 EV_COMMAND(3102, CmFRewind),
 EV_COMMAND(3103, CmFAuto),

 EV_COMMAND(3104, CmMnuShuffle),
 EV_COMMAND(3200, CmMnuForward),
 EV_COMMAND(3201, CmMnuBackward),
 EV_COMMAND(3105, CmMnuRepeat1),
 EV_COMMAND(3108, CmMnuRepeat),
 EV_COMMAND(1103, CmMnuHelp),
 EV_COMMAND(3107, CmAbout),
 EV_COMMAND(3100, CmActivate),
 EV_COMMAND(1101, CmMnuDisk),
 EV_COMMAND(1102, CmMnuInstr),
 EV_COMMAND(1100, CmMnuExit),
 EV_COMMAND(2103, CmLstNew),
 EV_COMMAND(2104, CmLstOpen),
 EV_COMMAND(2105, CmLstSave),
 EV_COMMAND(2106, CmLstSaveAs),
END_RESPONSE_TABLE;

/******************************************************************************/
// TMainFrameWindow Interface
/******************************************************************************/

class TMainFrameWindow : public TFrameWindow
{
  public:
   TDiskFrameWindow *DiskWnd;
   TInstrFrameWindow *InstrWnd;

   TPopupMenu *cntxt;
   TMainFrameWindow (TWindow* parent, const char far *title = APP_TITLE,
                   TWindow *clientWnd = 0, BOOL shrinkToClient = true);
   ~TMainFrameWindow();

   virtual void SetupWindow();
   void EvMove(TPoint &clientOrigin);
   void ShowRacks();

   DECLARE_RESPONSE_TABLE(TMainFrameWindow);
};


DEFINE_RESPONSE_TABLE1(TMainFrameWindow, TFrameWindow)
 EV_WM_MOVE,
END_RESPONSE_TABLE;

/******************************************************************************/
// Globals
/******************************************************************************/
TInstrDialog *dlgID;
TDiskDialog *dlgDD;
TMainDialog *dlgMD;

TMainFrameWindow *main_frame;
TSplashWindow* Splash = 0;


/*
  ##############################################################################
   The Implemenations
  ##############################################################################

   TPrefDlg
   TInstrDialog
   TInstrFrameWindow
   TDiskDialog
   TDiskFrameWindow
   TMainDialog
   TMainFrameWindow
*/

TInfoDlg::TInfoDlg(TWindow *parent)
 : TDialog(parent, "DLG_INFO") {};

void TInfoDlg::CmMail()
 {
  VWebHyperLink().Browse("mailto:poettering@usa.net");
 }

void TInfoDlg::CmHomepage()
 {
  VWebHyperLink().Browse("http://www.geocities.com/SiliconValley/Heights/7443");
 }

/******************************************************************************/
// TPrefDlg Implementation
/******************************************************************************/

TMIDASPage::TMIDASPage(TPropertySheet* parent)
 : TPropertyPage(parent, "DLG_2", "MIDAS Subsystem")
 {
  cb_Quality   = new TComboBox(this, 100);
  cb_Mixrate   = new TComboBox(this, 101);
  cb_Filter    = new TComboBox(this, 102);
  st_version   = new TStatic(this, 107);
  PageInfo.dwFlags &= ~ PSP_HASHELP;
 }

TMIDASPage::~TMIDASPage()
 {
 }

void TMIDASPage::SetupWindow()
 {
  TPropertyPage::SetupWindow();
  SetupGUI();
 }

void TMIDASPage::SetupGUI()
 {
  GetSheet()->SetWindowLong(GWL_EXSTYLE, GetSheet()->GetWindowLong(GWL_EXSTYLE) & ~WS_EX_CONTEXTHELP);
  INIT_QUALITYTABLE;
  INIT_MIXTABLE;
  INIT_FILTERTABLE;

  for (int i = 0; i <= CNVQUALITYCNT-1; i++)
   cb_Quality->AddString(CNVQUALITY(i));
  cb_Quality->SetSelIndex(MACfg.i_QualityIndex);

  for (int i = 0; i <= CNVMIXRATECNT-1; i++)
   cb_Mixrate->AddString(CNVMIXRATE(i));
  cb_Mixrate->SetSelIndex(MACfg.i_MixIndex);

  for (int i = 0; i <= CNVFILTERCNT-1; i++)
   cb_Filter->AddString(CNVFILTER(i));
  cb_Filter->SetSelIndex(MACfg.i_FilterIndex);

  char s[255];
  sprintf(s, "MIDAS library V%s", MIDASgetVersionString());
  st_version->SetText(s);
 }

int TMIDASPage::Apply(TNotify& not)
 {
  MACfg.i_QualityIndex = cb_Quality->GetSelIndex();
  MACfg.i_MixIndex = cb_Mixrate->GetSelIndex();
  MACfg.i_FilterIndex = cb_Filter->GetSelIndex();

  return TPropertyPage::Apply(not);
 }

TPrefPage::TPrefPage(TPropertySheet* parent)
 : TPropertyPage(parent, "DLG_3", "Preferences")
 {
  cb_LoadNames = new TCheckBox(this, 105);
  cb_BadFiles  = new TCheckBox(this, 106);
  cb_IconTNA   = new TCheckBox(this, 107);
  cb_ShowSplash = new TCheckBox(this, 101);

  PageInfo.dwFlags &= ~PSP_HASHELP;
 }

void TPrefPage::SetupWindow()
 {
  TPropertyPage::SetupWindow();
  SetupGUI();
 }

int TPrefPage::Apply(TNotify& not)
 {
  MACfg.b_LoadNames = cb_LoadNames->GetCheck();
  MACfg.b_WarnBadFile = cb_BadFiles->GetCheck();
  MACfg.b_IconTNA = cb_IconTNA->GetCheck();
  MACfg.ShowSplash = cb_ShowSplash->GetCheck();
  return TPropertyPage::Apply(not);
 }

void TPrefPage::SetupGUI()
 {
  cb_LoadNames->SetCheck(MACfg.b_LoadNames);
  cb_BadFiles->SetCheck(MACfg.b_WarnBadFile);
  cb_IconTNA->SetCheck(MACfg.b_IconTNA);
  cb_ShowSplash->SetCheck(MACfg.ShowSplash);
 }

/******************************************************************************/
// TInstrDialog Implementation
/******************************************************************************/
TInstrDialog::TInstrDialog(TWindow* parent, TResId resId, TModule* module)
             :TDialog(parent,resId,module), f("Courier New", 16)
 {
  InstrList = new TListBox(this, 100);
  dlgID = this;
 }

void TInstrDialog::SetupWindow()
 {
  TDialog::SetupWindow();
  InstrList->SetWindowFont(f, true);
 }

void TInstrDialog::UpdateInstrList()
 {
  InstrList->ClearList();
  if (midas.GetState(lpMIDASPlayer::Loaded))
   {
    for (int i = 0; i < midas.GetTrackInstrumentCount() -1; i++)
     {
      string instr = midas.GetTrackInstrumentName(i);
      instr.oem_to_ansi();
      InstrList->InsertString(instr.c_str(), -1);
     }
   }
  else
   {
    InstrList->InsertString(STR_NOINSTRUMENTSAVAILABLE, -1);
   }
 };

/******************************************************************************/
// TDiskDialog Implementation
/******************************************************************************/
TDiskDialog::TDiskDialog(TWindow* parent, TResId resId, TModule* module)
   : TDialog(parent,resId,module)
 {
   dlgDD = this;
   FileList = new TListWindow(this, 100);
   img = new TImageList(*GetApplication(), "BMP_MODULE", 16, 1, TColor(0, 130, 0), IMAGE_BITMAP, ILC_COLOR4);
   img->SetBkColor(TColor(255, 255, 255));

   ContextDMM = 0;
   OldDMM = 0;
 }

void TDiskDialog::SetupWindow()
 {
  TDialog::SetupWindow();
  SetupGUI();
  ProcessCmdLine();
  UpdateListView();
  if (*MACfg.fname != 0)
   midas.ReadPlayList(MACfg.fname);

  midas.PlayIndex(MACfg.JustPlaying);

  TPopupMenu *m = new TPopupMenu(TMenu(*GetApplication(), "MNU_DISK"));
  SetMenuDefaultItem(*m, 2100, false);
  AssignContextMenu(m);
  DragAcceptFiles(true);
  UpdateListView();
 }

void TDiskDialog::CleanupWindow()
 {
  TDialog::CleanupWindow();
  midas.WritePlayList();
  strcpy(MACfg.fname, midas.GetPlayListName().c_str());
  MACfg.JustPlaying = midas.GetTrackIndex();

  MACfg.width_fname = FileList->GetColumnWidth(0);
  MACfg.width_track = FileList->GetColumnWidth(1);
  MACfg.width_type = FileList->GetColumnWidth(2);
  MACfg.width_path = FileList->GetColumnWidth(3);
 }

void TDiskDialog::UpdateListView()
 {
  FileList->DeleteAllItems();

  TListWindItem o(STR_OTHER, 0);
  o.SetImageIndex(2);
  FileList->InsertItem(o);

  lpMIDASPlayer::lpDMMListIterator i(*midas.GetDMMList());
  while (i)
   {
    lpDMM *dmm = i.Current();
    AddModuleToListView(dmm);
    i++;
   }
 }

void TDiskDialog::SetupGUI()
 {
  FileList->InsertColumn(0, TListWindColumn(STR_FNAME, MACfg.width_fname));
  FileList->InsertColumn(1, TListWindColumn(STR_MNAME, MACfg.width_track));
  FileList->InsertColumn(2, TListWindColumn(STR_TYPE, MACfg.width_type));
  FileList->InsertColumn(3, TListWindColumn(STR_PATH, MACfg.width_path));

  FileList->SetImageList(*img, TListWindow::Small);
 }

void TDiskDialog::EvModuleDblclk()
 {
   TLwHitTestInfo pt;
   ::GetCursorPos(&pt.pt);
   ::ScreenToClient(FileList->HWindow, &pt.pt);
   int idx = FileList->HitTest(pt);

   TListWindItem lwi;
   lwi.SetIndex(idx);
   lwi.mask |= LVIF_PARAM;
   FileList->GetItem(lwi);
   ContextDMM = (lpDMM*) (lwi.GetItemData());

   if (ContextDMM == 0)
    AddNewModules();
   else
    CmPlay();

 }

void TDiskDialog::CmEmpty()
 {
  midas.Unload();
  midas.FreePlayList();
  UpdateListView();
  dlgID->UpdateInstrList();
  dlgMD->ShowStuckInfo();
 }

void TDiskDialog::CmRetrieveNames()
 {
  lpMIDASPlayer::lpDMMListIterator i(*midas.GetDMMList());
  TDialog *dlg = new TDialog(this, "DLG_1");
  GetApplication()->MakeWindow(dlg);
  SetCursor(0, IDC_WAIT);

  while (i)
   {
    i.Current()->RetrieveSongInfo();
    i++;
   }

  SetCursor(0, IDC_ARROW);
  dlg->CloseWindow();
  UpdateListView();
 }

void TDiskDialog::AddModuleToListView(lpDMM *dmm)
 {
  if (MACfg.b_LoadNames)
   dmm->RetrieveSongInfo();

  string file = dmm->GetFileName();

  string fn;
  if (file.rfind("\\") == NPOS)
   fn = file;
  else
   fn = string(file, file.rfind("\\")+1);

  TListWindItem i((char*) fn.c_str(), 0);
  i.SetItemData((LONG) dmm);
  i.SetIndex(FileList->GetItemCount());
  int idx = FileList->InsertItem(i);

  FileList->SetItemText(idx, TListWindItem((char*) dmm->GetTrackName().c_str(), 1));

  string ext;
  if (file.rfind(".") == NPOS)
   ext = STR_NO_EXTENSION;
  else
   ext = string(file, file.rfind(".")+1);
  FileList->SetItemText(idx, TListWindItem((char*)ext.c_str(), 2));

  string path;
  if (file.rfind("\\") == NPOS)
   path = file;
  else
   path = string(file, 0, file.rfind("\\"));

  FileList->SetItemText(idx, TListWindItem((char*)path.c_str(), 3));
 }

void TDiskDialog::AddModule(const char *fn, const char *track)
 {
  string file(fn);
  if (FileExists(file.c_str()))
   {
    file.to_lower();
    lpDMM *dmm = midas.AddModule(file.c_str(), track);
    if (dmm)
     AddModuleToListView(dmm);
   }
 }

void TDiskDialog::AddNewModules()
 {
  TFileOpenDialog::TData data(OFN_HIDEREADONLY | OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_ALLOWMULTISELECT | OFN_EXPLORER,
                           STR_MODTYPES, 0, "", "MOD");

  char s[8000], *oldFileName;
  oldFileName = data.FileName;
  data.FileName = s;
  data.MaxPath = sizeof(s);

  if (TFileOpenDialog(Parent, data).Execute() == IDOK)
   {
    SetCursor(0, IDC_WAIT);

    char *p = strchr(data.FileName, 0); p++;
    if (*p == 0)
     AddModule(data.FileName);
    else
     {
      while (*p != 0)
       {
        char s[MAX_PATH];
        strcpy(s, data.FileName);
        strcat(strcat(s, "\\"), p);
        AddModule(s);
        p = strchr(p, 0);
        p++;
       }
     }

    SetCursor(0, IDC_ARROW);
   }

  data.FileName = oldFileName;
 }

int TDiskDialog::FindDMMInListView(lpDMM* dmm)
 {
  if (!dmm) return -1;
  for (int i = 0; i < FileList->GetItemCount(); i++)
   {
    TListWindItem lwi;
    lwi.SetIndex(i);
    lwi.mask |= LVIF_PARAM;
    FileList->GetItem(lwi);
    lpDMM *dmm2 = (lpDMM*) (lwi.GetItemData());
    if (dmm == dmm2) return i;
   }
  return -1;
 }

void TDiskDialog::MarkModule()
 {
  int idx;

  idx = FindDMMInListView(OldDMM);

  if (idx != -1)
   {
    TListWindItem lvi;
    lvi.SetIndex(idx);
    lvi.SetImageIndex(0);
    FileList->SetItem(lvi);
   }

  idx = FindDMMInListView(midas.GetTrackDMM());

  if (idx != -1)
   {
    TListWindItem lvi;
    lvi.SetIndex(idx);
    lvi.SetImageIndex(1);
    FileList->SetItem(lvi);

    FileList->SetItemText(idx, TListWindItem((char*)midas.GetTrackName().c_str(), 1));
   }

  OldDMM = midas.GetTrackDMM();
 }

void TDiskDialog::EvContextMenu(HWND child, int x, int y)
 {
  TLwHitTestInfo pt;
  pt.pt.x = x;
  pt.pt.y = y;
  ::ScreenToClient(FileList->HWindow, &pt.pt);
  int idx = FileList->HitTest(pt);

  TListWindItem lwi;
  lwi.SetIndex(idx);
  lwi.mask |= LVIF_PARAM;
  FileList->GetItem(lwi);
  ContextDMM = (lpDMM*) (lwi.GetItemData());

  TPopupMenu *m = GetContextMenu();
  m->EnableMenuItem(2100, MF_BYCOMMAND | ((ContextDMM != 0) ? MF_ENABLED : MF_GRAYED));
  m->EnableMenuItem(2102, MF_BYCOMMAND | ((ContextDMM != 0) ? MF_ENABLED : MF_GRAYED));

  TDialog::EvContextMenu(child, x, y);
 }

void TDiskDialog::PlayModule()
 {
  if (ContextDMM)
   midas.PlayDMM(ContextDMM);
  else
   midas.Unload();

  if (!midas.GetState(lpMIDASPlayer::Loaded) && MACfg.b_WarnBadFile)
   {
    MessageBox("Could not load module. File is corrupt or not existent!", "Error");
   }

  MarkModule();
  dlgID->UpdateInstrList();
  dlgMD->ShowStuckInfo();
 }

void TDiskDialog::CmPlay()
 {
  PlayModule();
 }

void TDiskDialog::CmDelete()
 {
  bool b = (midas.GetTrackDMM() == ContextDMM);
  midas.DeleteDMM(ContextDMM);
  FileList->DeleteAnItem(FindDMMInListView(ContextDMM));

  if (b)
   {
    midas.Unload();
    MarkModule();
    dlgID->UpdateInstrList();
    dlgMD->ShowStuckInfo();
   }
 }

void TDiskDialog::CmAddFile()
 {
  AddNewModules();
 }

void TDiskDialog::CmLstNew()
 {
  CmLstOpen();
 }

void TDiskDialog::CmLstOpen()
 {
  TFileOpenDialog::TData data(OFN_HIDEREADONLY | OFN_PATHMUSTEXIST | OFN_EXPLORER,
                           STR_MPLTYPES, 0, "", "MPL");

  strcpy(data.FileName, midas.GetPlayListName().c_str());
  if (TFileOpenDialog(this, data).Execute() == IDOK)
   {
    midas.WritePlayList();
    midas.Unload();
    midas.FreePlayList();
    midas.ReadPlayList(data.FileName);
    UpdateListView();
    UpdateTitle();    
   }
 }

void TDiskDialog::CmLstSave()
 {
  midas.WritePlayList();
 }

void TDiskDialog::CmLstSaveAs()
 {
  TFileSaveDialog::TData data(OFN_HIDEREADONLY | OFN_PATHMUSTEXIST | OFN_EXPLORER,
                           STR_MPLTYPES, 0, "", "MPL");

  strcpy(data.FileName, midas.GetPlayListName().c_str());
  if (TFileSaveDialog(this, data).Execute() == IDOK)
   {
    midas.SetPlayListName(data.FileName);
    midas.WritePlayList();
    UpdateTitle();
   }
 }

void TDiskDialog::EvDropFiles(TDropInfo dropInfo)
 {
  for (int i = dropInfo.DragQueryFileCount()-1; i >= 0; i--)
   {
    char s[MAX_PATH];
    dropInfo.DragQueryFile(i, s, sizeof(s));
    AddModule(s);
   }
 }

void TDiskDialog::ProcessCmdLine()
 {
  for (int i = 1; i <= _argc-1; i++)
   {
    char s[MAX_PATH];
    strcpy(s, _argv[i]);
    char *p = strrchr(s, 92);
    if (p)
     AddModule(s);
    else
     {
      char path[MAX_PATH];
      strcpy(path, "X:\\");
      path[0] = (char) ('A' + getdisk());
      getcurdir(0, &path[3]);
      strcat(path, s);
      AddModule(path);
     }
   }
 }

void TDiskDialog::UpdateTitle()
 {
  string title(APP_TITLE);
  string fn;
  if (midas.GetPlayListName().rfind("\\") != NPOS)
   fn = string(midas.GetPlayListName(), midas.GetPlayListName().rfind("\\")+1);
  else
   fn = string(midas.GetPlayListName());

  if (fn.rfind(".") != NPOS)
   fn = string(fn, 0, fn.rfind("."));

  title += " - [" +  fn + "]";
  main_frame->SetCaption(title.c_str());
 }

int TDiskDialog::FileExists(const char *p)
 {
  ffblk t;
  int i = findfirst(p, &t, FA_NORMAL | FA_RDONLY | FA_HIDDEN);
  return (i != -1);
 }

/******************************************************************************/
// TMainDialog Implementation
/******************************************************************************/
TMainDialog::TMainDialog(TWindow* parent, TResId resId, TModule* module)
            :TDialog(parent,resId,module), f("Times New Roman", 28, 0, 0, 0, FW_NORMAL, true)
 {
   st_title = new TStatic(this, 100, 256);
   st_fname = new TStatic(this, 101, 256);
   st_type  = new TStatic(this, 102, 256);
   st_arr   = new TStatic(this, 103, 256);
   st_pat   = new TStatic(this, 104, 256);
   st_chan  = new TStatic(this, 105, 256);
   st_instr = new TStatic(this, 106, 256);
   sl_pos   = new THSlider(this, 115);
   sl_vol   = new TVSlider(this, 117);
   bt_play  = new TButton(this, 107);
   bt_stop  = new TButton(this, 108);
   bt_rewind  = new TButton(this, 111);
   bt_forward = new TButton(this, 112);
   bt_frewind = new TButton(this, 109);
   bt_fforward= new TButton(this, 110);
   bt_fauto   = new TButton(this, 113);
   cb_repeat  = new TCheckBox(this, 118);
   cb_repeat2 = new TCheckBox(this, 122);
   cb_disk    = new TCheckBox(this, 120);
   cb_instr   = new TCheckBox(this, 121);

   rb_shuffle = new TRadioButton(this, 119);
   rb_backward = new TRadioButton(this, 116);
   rb_forward = new TRadioButton(this, 114);

   dlgMD = this;

   Buffering_LastPos = -1;

   icoSmall = new TIcon(*GetApplication(), "ICO_SMALL");
   icoPlay = new TIcon(*GetApplication(), "ICO_PLAY");
   icoNothing = new TIcon(*GetApplication(), "ICO_NOTHING");

   hMMF = 0;

   pop = new TPopupMenu(TMenu(*GetApplication(), "MNU_TNA"));
   SetMenuDefaultItem(*pop, 3100, false);
 }

TMainDialog::~TMainDialog()
 {
  delete icoSmall;
  delete icoPlay;
  delete icoNothing;
  delete pop;
 }

void TMainDialog::CmPlay()
 {
  midas.Play(sl_pos->GetPosition());
  ShowVarInfo();
  UpdateState();
 };

void TMainDialog::CmStop()
 {
  midas.Stop();
  ShowVarInfo();
  UpdateState();
 }

void TMainDialog::SetupWindow()
 {
  TDialog::SetupWindow();
  SetupGUI();
  SetupOptions();
  TaskBarAddIcon(HWindow, WM_TNANOTIFY, 4711, *icoSmall, "modality");
  SetTimer(4711, 100);
  InitMMF();
  UpdateFlags();
  PostMessage(WM_AFTERINIT, 0, 0);
 }

void TMainDialog::CleanupWindow()
 {
  TDialog::CleanupWindow();
  KillTimer(4711);
  CloseMMF();
  TaskBarDeleteIcon(HWindow, 4711);
 }

void TMainDialog::ShowStuckInfo()
 {
  UpdateState();
  if (midas.GetState(lpMIDASPlayer::Loaded))
   {
    char s[255], s2[255];
    st_title->SetText(midas.GetTrackName().c_str());

    TaskBarSetIcon(*this, 4711, (midas.GetState(lpMIDASPlayer::Playing) ? *icoPlay : *icoSmall));

    string path(midas.GetTrackFile());

    string fn;
    if (path.rfind("\\") != NPOS)
     fn = string(path, path.rfind("\\")+1, NPOS);
    else
     fn = path;
    st_fname->SetText(fn.c_str());

    string sfx;
    if (path.rfind(".") != NPOS)
     sfx = string(path, path.rfind(".")+1, NPOS);
    else
     sfx = STR_NOTYPE;
    st_type->SetText(sfx.c_str());

    itoa(midas.GetTrackLength(), s, 10);
    itoa(sl_pos->GetPosition()+1, s2, 10);
    strcat(strcat(s2, "/"), s);
    st_arr->SetText(s2);
    itoa(midas.GetTrackPatternCount(), s, 10);
    st_pat->SetText(s);
    itoa(midas.GetTrackChannelCount(), s, 10);
    st_chan->SetText(s);
    itoa(midas.GetTrackInstrumentCount(), s, 10);
    st_instr->SetText(s);

    sl_pos->SetRange(0, midas.GetTrackLength()-1);

   }
  else
   {
    st_instr->SetText(STR_NOTAVAILABLE);
    st_arr->SetText(STR_NOTAVAILABLE);
    st_pat->SetText(STR_NOTAVAILABLE);
    st_chan->SetText(STR_NOTAVAILABLE);
    st_type->SetText(STR_NOTAVAILABLE);
    st_fname->SetText(STR_NOTAVAILABLE);
    st_title->SetText(STR_NOTAVAILABLE);
    sl_pos->SetRange(0, 0);
   }
 }

void TMainDialog::ShowVarInfo()
 {
  if (midas.GetState(lpMIDASPlayer::Loaded))
   {
    int pos;

    if (midas.GetState(lpMIDASPlayer::Playing))
     pos = midas.GetTrackActualPos();
    else
     pos = sl_pos->GetPosition();

    if (Buffering_LastPos != pos)
     {
      sl_pos->SetPosition(pos);

      char s[255], s2[255];
      itoa(midas.GetTrackLength(), s, 10);
      itoa(pos+1, s2, 10);
      strcat(strcat(s2, "/"), s);
      st_arr->SetText(s2);
      Buffering_LastPos = pos;

      sprintf(s2, "%s.%u/%u", &s, pos+1, midas.GetTrackLength());
      TaskBarSetToolTip(HWindow, 4711, s2);
     }
    }
   else
    {
     sl_pos->SetPosition(0);
     st_arr->SetText(STR_NOTAVAILABLE);
     TaskBarSetToolTip(HWindow, 4711, STR_NOTAVAILABLE);
    }
 }

void TMainDialog::SetupOptions()
 {
  midas.Pause();
  INIT_MIXTABLE;
  MIDASsetOption(MIDAS_OPTION_MIXRATE, GETMIXRATE);
  MIDASsetOption(MIDAS_OPTION_OUTPUTMODE, GETQUALITY);
  MIDASsetOption(MIDAS_OPTION_FILTER_MODE, GETFILTER);
  midas.Resume();
  midas.SetVolume(MACfg.volume);
 }

void TMainDialog::EvTimer(uint timerId)
 {
  if (timerId == 4711)
   {
    ProcessMMF();
    midas.UpdateSongInfo();

    if (midas.TrackChanged())
     {
      ShowStuckInfo();
      dlgDD->MarkModule();
      dlgID->UpdateInstrList();
     }

    ShowVarInfo();
   }
 }

void TMainDialog::SetupGUI()
 {
  st_title->SetWindowFont(f, true);

  sl_pos->SetPageMagnitude(1);
  sl_pos->SetLineMagnitude(1);
  sl_pos->SetRuler(1, true);
  sl_pos->SetRange(0, 0);

  sl_vol->SetPageMagnitude(8);
  sl_vol->SetLineMagnitude(1);
  sl_vol->SetRuler(1, true);
  sl_vol->SetRange(0, 64);

  sl_vol->SetPosition(64-MACfg.volume);

  cb_repeat->SetCheck(MACfg.RepeatFlag);
  rb_shuffle->SetCheck(MACfg.ShuffleFlag);
  rb_forward->SetCheck(MACfg.ForwardFlag);
  rb_backward->SetCheck(MACfg.BackwardFlag);
  cb_repeat2->SetCheck(MACfg.Repeat2Flag);
  cb_disk->SetCheck(MACfg.ShowDisk);
  cb_instr->SetCheck(MACfg.ShowInstr);

  TIcon *i = new TIcon(*GetModule(), "ICO_BUTTON_PLAY");
  bt_play->SendMessage(BM_SETIMAGE, (WPARAM) IMAGE_ICON, (LPARAM) (HANDLE) (HICON) (*i));

  i = new TIcon(*GetModule(), "ICO_BUTTON_STOP");
  bt_stop->SendMessage(BM_SETIMAGE, (WPARAM) IMAGE_ICON, (LPARAM) (HANDLE) (HICON) (*i));

  i = new TIcon(*GetModule(), "ICO_BUTTON_FORWARD");
  bt_forward->SendMessage(BM_SETIMAGE, (WPARAM) IMAGE_ICON, (LPARAM) (HANDLE) (HICON) (*i));

  i = new TIcon(*GetModule(), "ICO_BUTTON_BACKWARD");
  bt_rewind->SendMessage(BM_SETIMAGE, (WPARAM) IMAGE_ICON, (LPARAM) (HANDLE) (HICON) (*i));

  i = new TIcon(*GetModule(), "ICO_BUTTON_FFORWARD");
  bt_fforward->SendMessage(BM_SETIMAGE, (WPARAM) IMAGE_ICON, (LPARAM) (HANDLE) (HICON) (*i));

  i = new TIcon(*GetModule(), "ICO_BUTTON_FBACKWARD");
  bt_frewind->SendMessage(BM_SETIMAGE, (WPARAM) IMAGE_ICON, (LPARAM) (HANDLE) (HICON) (*i));

  i = new TIcon(*GetModule(), "ICO_BUTTON_AUTO");
  bt_fauto->SendMessage(BM_SETIMAGE, (WPARAM) IMAGE_ICON, (LPARAM) (HANDLE) (HICON) (*i));

 }

void TMainDialog::EvTrack()
 {
  if (midas.GetState(lpMIDASPlayer::Playing))
   midas.SetTrackActualPos(sl_pos->GetPosition());

  ShowVarInfo();
 }

void TMainDialog::EvVol()
 {
  MACfg.volume = 64-sl_vol->GetPosition();
  if (midas.GetState(lpMIDASPlayer::Playing))
   midas.SetVolume(MACfg.volume);
 }

void TMainDialog::UpdateState()
 {
  bt_stop->EnableWindow(midas.GetState(lpMIDASPlayer::Playing));
  bt_play->EnableWindow(midas.GetState(lpMIDASPlayer::Loaded) && !midas.GetState(lpMIDASPlayer::Playing));
  bt_forward->EnableWindow(midas.GetState(lpMIDASPlayer::Loaded));
  bt_rewind->EnableWindow(midas.GetState(lpMIDASPlayer::Loaded));
  sl_pos->EnableWindow(midas.GetState(lpMIDASPlayer::Loaded));

  bt_fforward->EnableWindow(midas.GetDMMList()->GetItemsInContainer() >= 1);
  bt_frewind->EnableWindow(midas.GetDMMList()->GetItemsInContainer() >= 1);
  bt_fauto->EnableWindow(midas.GetDMMList()->GetItemsInContainer() >= 1);

  SetDefaultId(midas.GetState(lpMIDASPlayer::Playing) ? bt_stop->GetDlgCtrlID() : bt_play->GetDlgCtrlID());

  TaskBarSetIcon(HWindow, 4711,
   (midas.GetState(lpMIDASPlayer::Playing) ? *icoPlay :
   (midas.GetState(lpMIDASPlayer::Loaded)  ? *icoSmall : *icoNothing)));
 }

void TMainDialog::CmForward()
 {
  if (midas.GetState(lpMIDASPlayer::Playing))
   {
    midas.SetTrackActualPos(midas.GetTrackActualPos()+1);
    ShowVarInfo();
   }
 }

void TMainDialog::CmRewind()
 {
  if (midas.GetState(lpMIDASPlayer::Playing))
   {
    midas.SetTrackActualPos(midas.GetTrackActualPos()-1);
    ShowVarInfo();
   }
 }

LPARAM TMainDialog::EvAfterInit(WPARAM, LPARAM)
 {
  dlgID->UpdateInstrList();
  UpdateFlags();
  ShowStuckInfo();
  UpdateState();
  return 0;
 }

void TMainDialog::CmRepeat()
 {
  MACfg.RepeatFlag = (cb_repeat->GetCheck() != 0);
  UpdateFlags();
 }

void TMainDialog::CmShuffle()
 {
  MACfg.ShuffleFlag = rb_shuffle->GetCheck();
  if (MACfg.ShuffleFlag)
   {
    MACfg.BackwardFlag = 0;
    MACfg.ForwardFlag = 0;
   }
  UpdateFlags();
 }

void TMainDialog::CmStBackward()
 {
  MACfg.BackwardFlag = rb_backward->GetCheck();
  if (MACfg.BackwardFlag)
   {
    MACfg.ShuffleFlag = 0;
    MACfg.ForwardFlag = 0;
   }
  UpdateFlags();
 }

void TMainDialog::CmStForward()
 {
  MACfg.ForwardFlag = rb_forward->GetCheck();
  if (MACfg.ForwardFlag)
   {
    MACfg.BackwardFlag = 0;
    MACfg.ShuffleFlag = 0;
   }
  UpdateFlags();
 }

void TMainDialog::CmRepeat2()
 {
  MACfg.Repeat2Flag = (cb_repeat2->GetCheck() != 0);
  UpdateFlags();
 }

void TMainDialog::CmDisk()
 {
  MACfg.ShowDisk = !MACfg.ShowDisk;
  main_frame->ShowRacks();
  UpdateFlags();
 }

void TMainDialog::CmInstr()
 {
  MACfg.ShowInstr = !MACfg.ShowInstr;
  main_frame->ShowRacks();
  UpdateFlags();
 }

LRESULT TMainDialog::EvTNANotify(WPARAM w, LPARAM l)
 {
  if (w == 4711)
   {
    switch (LOWORD(l))
     {
      case WM_LBUTTONDBLCLK:
       CmActivate();
      break;
      case WM_RBUTTONUP:
       POINT p;
       ::GetCursorPos(&p);
       pop->TrackPopupMenu(TPM_RIGHTBUTTON, p.x, p.y, 0, *Parent);
      break;
     }
   }
  return 1;
 }

void TMainDialog::ProcessMMF()
 {
  if (hMMF == 0) return;
  if (hMMF == INVALID_HANDLE_VALUE) return;

  char *buf;
  buf = (char*) MapViewOfFile(hMMF, FILE_MAP_ALL_ACCESS, 0, 0, APP_MAXMMFSIZE);
  if (buf == 0)
   {
    CloseMMF();
    MessageBox("Could not map MMF for IPC!", "Error");
    return;
   }

  char &change = buf[0];
  if (change)
   {
    char *p = buf+1;
    while (*p != 0)
     {
      dlgDD->AddModule(p);
      p = strchr(p, 0);
      if (p == 0) break;
      p++;
     }

    change = 0;
    SetForegroundWindow(*this);
   }

  FlushViewOfFile((LPCVOID) buf, APP_MAXMMFSIZE);
  UnmapViewOfFile((LPCVOID) buf);
 }

void TMainDialog::InitMMF()
 {
  hMMF = CreateFileMapping((HANDLE)0xFFFFFFFF, 0, PAGE_READWRITE, 0, APP_MAXMMFSIZE, APP_MMF);
  if (hMMF == INVALID_HANDLE_VALUE) hMMF = 0;
  if (hMMF == 0)
   MessageBox("Could not open MMF for IPC.", "Error");

  char * buf = (char*) MapViewOfFile(hMMF, FILE_MAP_ALL_ACCESS, 0, 0, APP_MAXMMFSIZE);
  if (buf == 0)
   {
    CloseMMF();
    MessageBox("Could not map MMF for IPC!", "Error");
    return;
   }

  buf[0] = 0;

  FlushViewOfFile((LPCVOID) buf, APP_MAXMMFSIZE);
  UnmapViewOfFile((LPCVOID) buf);
 }

void TMainDialog::CloseMMF()
 {
  CloseHandle(hMMF);
  hMMF = 0;
 }

void TMainDialog::CmPref()
 {
  TPropertySheet *dlg = new TPropertySheet(this, "Options", 0, 0, PSH_NOAPPLYNOW);

  new TPrefPage(dlg);
  new TMIDASPage(dlg);

  if (dlg->Execute() == 1)
   SetupOptions();
  delete dlg;
 }

void TMainDialog::CmFForward()
 {
  midas.PlayNextModule(lpMIDASPlayer::SequentialForward);
  dlgDD->MarkModule();
  dlgID->UpdateInstrList();
  ShowStuckInfo();
 }

void TMainDialog::CmFRewind()
 {
  midas.PlayNextModule(lpMIDASPlayer::SequentialBackward);
  dlgDD->MarkModule();
  dlgID->UpdateInstrList();
  ShowStuckInfo();
 }

void TMainDialog::CmFAuto()
 {
  midas.PlayNextModule();
  dlgDD->MarkModule();
  dlgID->UpdateInstrList();
  ShowStuckInfo();
 }

void TMainDialog::CmMnuShuffle()
 {
  MACfg.ShuffleFlag = !MACfg.ShuffleFlag;
  if (MACfg.ShuffleFlag)
   {
    MACfg.BackwardFlag = 0;
    MACfg.ForwardFlag = 0;
   }

  UpdateFlags();
 }

void TMainDialog::CmMnuForward()
 {
  MACfg.ForwardFlag = !MACfg.ForwardFlag;
  if (MACfg.ForwardFlag)
   {
    MACfg.BackwardFlag = 0;
    MACfg.ShuffleFlag = 0;
   }
  UpdateFlags();
 }

void TMainDialog::CmMnuBackward()
 {
  MACfg.BackwardFlag = !MACfg.BackwardFlag;
  if (MACfg.BackwardFlag)
   {
    MACfg.ForwardFlag = 0;
    MACfg.ShuffleFlag = 0;
   }

  UpdateFlags();
 }

void TMainDialog::CmMnuRepeat1()
 {
  MACfg.RepeatFlag = !MACfg.RepeatFlag;
  UpdateFlags();
 }

void TMainDialog::CmMnuRepeat()
 {
  MACfg.Repeat2Flag = !MACfg.Repeat2Flag;
  UpdateFlags();
 }

void ChkMnu(TMenu &m)
 {
  m.CheckMenuItem(3104, MF_BYCOMMAND | (MACfg.ShuffleFlag ? MF_CHECKED : 0));
  m.CheckMenuItem(3105, MF_BYCOMMAND | (MACfg.RepeatFlag ? MF_CHECKED : 0));
  m.CheckMenuItem(3108, MF_BYCOMMAND | (MACfg.Repeat2Flag ? MF_CHECKED : 0));
  m.CheckMenuItem(3200, MF_BYCOMMAND | (MACfg.ForwardFlag ? MF_CHECKED : 0));
  m.CheckMenuItem(3201, MF_BYCOMMAND | (MACfg.BackwardFlag ? MF_CHECKED : 0));
  m.CheckMenuItem(1101, MF_BYCOMMAND | (MACfg.ShowDisk ? MF_CHECKED : 0));
  m.CheckMenuItem(1102, MF_BYCOMMAND | (MACfg.ShowInstr ? MF_CHECKED : 0));
 }

void TMainDialog::UpdateFlags()
 {
  midas.SetPlayOrder(MACfg.ShuffleFlag ? lpMIDASPlayer::Random :
                    (MACfg.RepeatFlag ? lpMIDASPlayer::Repeat :
                    (MACfg.ForwardFlag ? lpMIDASPlayer::SequentialForward :
                     lpMIDASPlayer::SequentialBackward)));
  midas.SetClipping(MACfg.Repeat2Flag ? lpMIDASPlayer::TurnAround : lpMIDASPlayer::StopAfter);


  cb_disk->SetCheck(MACfg.ShowDisk);
  cb_instr->SetCheck(MACfg.ShowInstr);
  rb_shuffle->SetCheck(MACfg.ShuffleFlag);
  rb_backward->SetCheck(MACfg.BackwardFlag);
  rb_forward->SetCheck(MACfg.ForwardFlag);
  cb_repeat->SetCheck(MACfg.RepeatFlag);
  cb_repeat2->SetCheck(MACfg.Repeat2Flag);

  ChkMnu(*pop);
  ChkMnu(TMenu(TMenu(Parent->GetMenu()).GetSubMenu(1)));
  ChkMnu(TMenu(TMenu(Parent->GetMenu()).GetSubMenu(2)));
  ChkMnu(TMenu(main_frame->cntxt->GetSubMenu(1)));
  ChkMnu(TMenu(main_frame->cntxt->GetSubMenu(2)));
 }

void TMainDialog::CmAbout()
 {
  TDialog *dlg = new TInfoDlg(this);
  dlg->Execute();
  delete dlg;
 }

void TMainDialog::CmActivate()
 {
  main_frame->ShowWindow(SW_SHOW);
  SetForegroundWindow(*main_frame);
  main_frame->ShowWindow(SW_RESTORE);
 }

void TMainDialog::CmMnuDisk()
 {
  MACfg.ShowDisk = !MACfg.ShowDisk;
  UpdateFlags();
  main_frame->ShowRacks();
 }

void TMainDialog::CmMnuInstr()
 {
  MACfg.ShowInstr = !MACfg.ShowInstr;
  UpdateFlags();
  main_frame->ShowRacks();
 }

void TMainDialog::CmMnuExit()
 {
  PostQuitMessage(0);
 }

void TMainDialog::CmLstNew()
 {
  dlgDD->CmLstNew();
 }

void TMainDialog::CmLstOpen()
 {
  dlgDD->CmLstOpen();
 }

void TMainDialog::CmLstSave()
 {
  dlgDD->CmLstSave();
 }

void TMainDialog::CmLstSaveAs()
 {
  dlgDD->CmLstSaveAs();
 }

void TMainDialog::CmMnuHelp()
 {
  WinHelp("modality.hlp", HELP_INDEX, 0);
 }

/******************************************************************************/
// TMainFrameWindow Implementation
/******************************************************************************/
TMainFrameWindow::TMainFrameWindow (TWindow* parent, const char far *title,
                   TWindow *clientWnd, BOOL shrinkToClient)
                  :TFrameWindow (parent, title, clientWnd, shrinkToClient)
 {
  Attr.Style &= ~WS_THICKFRAME &~WS_MAXIMIZEBOX ;
  Attr.ExStyle |= WS_EX_DLGMODALFRAME | WS_EX_APPWINDOW;
  main_frame = this;

  SetIcon(GetApplication(),"ICO_MAIN");
  SetIconSm(GetApplication(),"ICO_SMALL");

  cntxt = new TPopupMenu(TMenu(*GetApplication(), "MNU_MAIN"));
 }

TMainFrameWindow::~TMainFrameWindow()
 {
 }

void TMainFrameWindow::SetupWindow()
 {
   TFrameWindow::SetupWindow();

   DiskWnd = new TDiskFrameWindow(this, NULL, new TDiskDialog(0));
   InstrWnd = new TInstrFrameWindow(this, NULL, new TInstrDialog(0));

   DiskWnd->Create();
   InstrWnd->Create();

   ShowRacks();

   AssignContextMenu(cntxt);
   AssignMenu("MNU_MAIN");
   EnableKBHandler();
 };

void TMainFrameWindow::EvMove(TPoint &clientOrigin)
 {
  TFrameWindow::EvMove(clientOrigin);
  ShowRacks();
 }

#define YSPACE 2
void TMainFrameWindow::ShowRacks()
 {
  if (!IsIconic())
   {
    if (MACfg.ShowDisk)
     DiskWnd->SetWindowPos(0, Attr.X, Attr.Y+Attr.H+YSPACE, Attr.W, DiskWnd->Attr.H, SWP_NOZORDER | SWP_SHOWWINDOW | SWP_NOACTIVATE);
    else
     DiskWnd->SetWindowPos(0, 0, 0, 0, 0, SWP_NOZORDER | SWP_NOSIZE | SWP_NOMOVE | SWP_HIDEWINDOW | SWP_NOACTIVATE);

    if (MACfg.ShowInstr)
     {
      if (MACfg.ShowDisk)
       InstrWnd->SetWindowPos(0, Attr.X, Attr.Y+Attr.H+DiskWnd->Attr.H+2*YSPACE, Attr.W, InstrWnd->Attr.H, SWP_NOZORDER | SWP_SHOWWINDOW | SWP_NOACTIVATE);
      else
       InstrWnd->SetWindowPos(0, Attr.X, Attr.Y+Attr.H+YSPACE, Attr.W, InstrWnd->Attr.H, SWP_NOZORDER | SWP_SHOWWINDOW | SWP_NOACTIVATE);
     }
    else
     InstrWnd->SetWindowPos(0, 0, 0, 0, 0, SWP_NOZORDER | SWP_NOSIZE | SWP_NOMOVE | SWP_HIDEWINDOW | SWP_NOACTIVATE);
   }
  else
   {
    if (MACfg.b_IconTNA) ShowWindow(SW_HIDE);
   }
 }

/******************************************************************************/
// TMainApp Interface+Implementation
/******************************************************************************/
class TMainApp : public TApplication
{
  public:
   TMainApp(const char far* name = 0, TModule*& gModule = ::Module, TAppDictionary* appDict = 0);
   ~TMainApp();

   void InitMainWindow();
   void SendArgs();
};

TMainApp::TMainApp(const char far* name, TModule*& gModule, TAppDictionary* appDict)
 :TApplication(name, gModule, appDict)
 {
  if (IsProcessLoaded("MODALITY") > 1) SendArgs();
  randomize();
  CFG_INIT;
  CFG_LOAD;
 }

void TMainApp::InitMainWindow()
 {
  if (MACfg.ShowSplash)
   {
    try
     {
      TDib *dib = new TDib("modality.bmp");
      ::Splash = new TSplashWindow(*dib, 300, 300,
       TSplashWindow::CaptureMouse | TSplashWindow::ShrinkToFit,
       3000, "", this);
      ::Splash->Create();
     }
    catch (TXGdi)
     {}
   }

  SetMainWindow(new TMainFrameWindow(0, APP_TITLE, new TMainDialog(0)));
  EnableCtl3d();
 }

TMainApp::~TMainApp()
 {
  CFG_SAVE;
 }


void TMainApp::SendArgs()
 {
  ::MessageBox(0, "Because modAlity is already in memory, the command line parameters are passed to this instance!", "modAlity", MB_OK);

  HANDLE hMMF;
  hMMF = OpenFileMapping(FILE_MAP_ALL_ACCESS, 0, APP_MMF);
  if (hMMF)
   {
    char *buf;
    buf = (char*) MapViewOfFile(hMMF, FILE_MAP_ALL_ACCESS, 0, 0, APP_MAXMMFSIZE);
    if (buf)
     {
      char *p = buf+1;
      for (int i = 1; i <= _argc-1; i++)
       {
        p = stpcpy(p, _argv[i]) + 1;
       }
      *p = 0;

      buf[0] = 1;

      FlushViewOfFile((LPCVOID) buf,  APP_MAXMMFSIZE);
      UnmapViewOfFile((LPCVOID) buf);
     }
    else
      MessageBox(0, "Could not map MMF for IPC!", "Error");


    CloseHandle(hMMF);
   }
  else
   MessageBox(0, "Could not reopen MMF for IPC!", "Error");

  exit(EXIT_SUCCESS);
 }

int OwlMain(int, char*[])
{
 return  TMainApp(APP_TITLE).Run();
}
