#ifndef modalityh
#define modalityh

#define APP_TITLE "modAlity"

#define WM_AFTERINIT WM_USER+100
#define WM_TNANOTIFY WM_USER+101

#define STR_OTHER "[Not in list...]"
#define STR_FNAME "Filename"
#define STR_TYPE  "Type"
#define STR_PATH  "Path"
#define STR_MNAME "Module-name"
#define STR_NOTYPE "No type"
#define STR_NONAME "[No name]"
#define STR_NOTAVAILABLE "n/a"
#define STR_MODTYPES "All Modules|*.mod;*.s3m;*.xm|Amiga-Modules (*.mod)|*.mod|ScreamTracker3-Modules (*.s3m)|*.s3m|Xtended Modules (*.xm)|*.xm|All files|*.*"
#define STR_MPLTYPES "modAlity Playlists|*.MPL|All files|*.*"
#define STR_MPL "MPL"
#define STR_MODALITY APP_TITLE
#define STR_BADMODULE "Bad Module! Please check its integrity!"
#define STR_ACTIVATE "[------>> ZUTT <<-----]"
#define APP_REG_PATH "Software\\Poettering\\ModAlity\\V1.0BETA"
#define APP_REG_ROOT HKEY_CURRENT_USER
#define APP_REG_KEY "BinaryConfig"
#define STR_NOINSTRUMENTSAVAILABLE "No instruments available."
#define APP_MAXMMFSIZE 0xFFFFFF
#define APP_MMF "modaliyt12"

#include <winsys\registry.h>

struct TMAConfig
 {
  int b_WarnBadFile;
  int b_LoadNames;
  int i_MixIndex;
  int i_QualityIndex;
  int i_FilterIndex;
  int obsolete1;
  int obsolete2;
  unsigned volume;
  int RepeatFlag;
  int ShuffleFlag;
  int ShowDisk, ShowInstr;
  int b_IconTNA;
  int obsolete3;
  int Repeat2Flag;
  char fname[MAX_PATH];
  signed int JustPlaying;
  int ForwardFlag;
  int BackwardFlag;
  bool ShowSplash;
  int width_fname;
  int width_type;
  int width_track;
  int width_path;
 };

TMAConfig MACfg;
#include <dir.h>

#define CFG_INIT { MACfg.b_WarnBadFile=0; \
                   MACfg.b_LoadNames=0; \
                   MACfg.i_MixIndex=0; \
                   MACfg.i_QualityIndex=0; \
                   MACfg.i_FilterIndex=1; \
                   MACfg.volume = 64; \
                   MACfg.RepeatFlag = 0; \
                   MACfg.Repeat2Flag = 1; \
                   MACfg.ShuffleFlag = 0; \
                   MACfg.ShowDisk = 1; \
                   MACfg.ShowInstr = 0;\
                   MACfg.b_IconTNA = 1; \
                   strcpy(MACfg.fname, "X:\\"); \
                   MACfg.fname[0] = (char) ('A' + (char) getdisk()); \
                   getcurdir(0, &MACfg.fname[3]); \
                   strcat(MACfg.fname, "\\modAlity.MPL"); \
                   MACfg.ForwardFlag = 1; \
                   MACfg.BackwardFlag = 0; \
                   MACfg.ShowSplash = 1; \
                   MACfg.width_fname = 100; \
                   MACfg.width_type = 100; \
                   MACfg.width_track = 100; \
                   MACfg.width_path = 100;}

#define CFG_LOAD { \
  uint32 size = sizeof(MACfg); \
  uint32 type = REG_BINARY; \
  TRegKey r(APP_REG_ROOT, APP_REG_PATH); \
  r.QueryValue(APP_REG_KEY, &type, (uint8*) &MACfg, &size); \
 }

#define CFG_SAVE { \
  TRegKey r(APP_REG_ROOT, APP_REG_PATH); \
  r.SetValue(APP_REG_KEY, REG_BINARY, (uint8*) &MACfg, sizeof(MACfg)); \
 }

#define CNVMIXRATECNT 5
#define INIT_MIXTABLE  \
 char *MixRateTbl[CNVMIXRATECNT] = {"44100 Hz", "33075 Hz", "22050 Hz", "11025 Hz", "8000 Hz"}; \
 int MixRateTbl2[CNVMIXRATECNT] = {44100, 33075, 22050, 11025, 8000};
#define CNVMIXRATE(i) MixRateTbl[i]
#define CNVMIXRATE2(i) MixRateTbl2[i]
#define GETMIXRATE CNVMIXRATE2(MACfg.i_MixIndex)

#define CNVQUALITYCNT 4
#define INIT_QUALITYTABLE char *QualityTbl[CNVQUALITYCNT] = {"16Bit Stereo", "16Bit Mono", "8Bit Stereo", "8Bit Mono"};
#define CNVQUALITY(i) QualityTbl[i]
#define CNVQUALITY2(i) ((i==0) ? MIDAS_MODE_16BIT_STEREO : ((i==1) ? MIDAS_MODE_16BIT_MONO : ((i==2) ? MIDAS_MODE_8BIT_STEREO : MIDAS_MODE_8BIT_MONO)))
#define GETQUALITY CNVQUALITY2(MACfg.i_QualityIndex)

#define CNVFILTERCNT 3
#define INIT_FILTERTABLE char *FilterTbl[CNVFILTERCNT] = {"More", "None", "Less"};
#define CNVFILTER(i) FilterTbl[i]
#define CNVFILTER2(i) ((i==0) ? MIDAS_FILTER_MORE : ((i==1) ? MIDAS_FILTER_NONE : MIDAS_FILTER_LESS))
#define GETFILTER CNVFILTER2(MACfg.i_FilterIndex)

#endif modalityh
